
theory Option imports Main
begin


use_thy Monad



thymorph t : MonadOpEta \<longrightarrow> Option
  maps [("'a MonadType.M" \<mapsto> "'a Datatype.option")]

     
(* We need only the const bind, so we get it by instantiation. 
   Const eta is already given by Datatype.option.Some *)
t_instantiate MonadOps mapping t

(* Now we can define the bind operation and 
   prove the monad properties *)
primrec
"(None >>= f) = None"
"((Some x) >>= f) = f x" 

(* A non-axiomatic instantiation ... *)
t_instantiate MonadAxms mapping t'

(* Proving the goals *)
lemma opt_runit:  "(t >>= Some) = t"
by(case_tac t, simp_all)

lemma opt_assoc:  "(s >>= t >>= u) = (s >>= (\<lambda>x. t x >>= u))" 
by(case_tac s, simp_all)

lemma opt_inj: "Some x = Some y \<Longrightarrow> x= y" by simp

(* Now we can construct the theory morphism from MonadAxms to Option ... *) 
thymorph t by_sigmorph t''


(* ... and instantiate the monad *)
t_instantiate Monad mapping t

translate_thm "Monad.mapF_joinM'" as "" along t'
translate_thm "Monad.lift_eta" as lift1 along t'
translate_thm "Monad.lift_eta2" as "" along t'



end
