
theory SetMon imports Main
begin

use_thy Monad

thymorph t : MonadOpBind \<longrightarrow> SetMon
maps [("'a MonadType.M" \<mapsto> "'a set")]
     [("MonadOpBind.bind" \<mapsto> "UNION")]

(* Get eta *)
t_instantiate MonadOps mapping t

defs
set_eta_def  : "eta x \<equiv> {x}"

t_instantiate MonadAxms mapping t'




lemma mon_assoc:
"UNION (UNION s t) u = (UN x:s. UNION (t x) u)"  (is "?L = ?R")
proof 
 show "?L <= ?R"
 by (simp add: UNION_def, rule subsetI, clarsimp, intro bexI, assumption+)
next
 show "?R <= ?L"
 by (simp add: UNION_def, rule subsetI, clarsimp, rule exI, rule conjI, intro bexI, assumption+)
qed

lemma mon_lunit:
"UNION (eta x) t = t x"
by (simp add: UNION_def set_eta_def)

lemma mon_runit:
"UNION t eta = t"
by (simp add: UNION_def set_eta_def)

lemma mon_eta_inj:
"eta x = eta y ==> x = y"
by (simp add: set_eta_def)

thymorph t by_sigmorph t''

t_instantiate Monad mapping t
without_syntax (* cannot use monad syntax here because UNION does not have the '>>=' syntax *) 

translate_thm "Monad.mapF_joinM" as "" along t'
translate_thm "Monad.lift_eta" as "" along t'
translate_thm "Monad.lift_eta2" as "" along t'


end