
theory Concat_Inst imports TailRec_nat
begin

use_thy TailRec

subsection {* Instantiation *}

thymorph i : Main \<longrightarrow> Concat_Inst

typedecl D
types string = "D list"

t_instantiate S mapping i
inst_types: [("Monoid.a" |-> "string")]
renames: [("Monoid.p" |-> app),
          ("Monoid.z" |-> eps),
          ("S.s" |-> concat)]

defs
app_def : "app l r \<equiv> l @ r"
eps_def : "eps \<equiv> Nil"

recdef concat "measure length"
  "concat l = (if l = [] then eps else (app (hd l) (concat (tl l)))) " 


subsection {* Proof of the four rules from TailRec parameters *}

lemma append_LOne: "app eps x = x"
  by (simp add: app_def eps_def)

lemma append_ROne: "app x eps = x"
  by (simp add: app_def eps_def)

lemma append_Assoc: "app u (app v c) = app (app u v) c" 
  by (simp add: app_def)

lemma concat_ax: "concat x = (if (x = []) then eps else (app (hd x) (concat (tl x))))"
  by (rule concat.simps)


thymorph t by_sigmorph i'

subsection {* Constructing theory morphism from TailRec to Concat_Inst *}

t_instantiate TailRec mapping t 
renames: [("TailRec.s2" |-> fastcat),
          ("TailRec.s2_def" |-> fastcat_def)] 

translate_thm "TailRec.TailRec" as fastcat_eq along t'

end


