theory Foldr_Inst imports TailRec_nat 
begin

text {* Another interesting instance of TailRec is the following: *}

lemma foldr_prop: "foldr f u e = (if u = [] then e else f (hd u) (foldr f (tl u) e))"
by (case_tac u, simp_all)
  

lemma foldl_prop: "foldl f e u = (if u = [] then e else (foldl f (f e (hd u)) (tl u)))"
by (case_tac u, simp_all)
  


theorem foldlr: 

assumes mleft: "\<And>x. f e x = x" 
    and mright: "\<And>x. f x e = x"
    and massoc: "\<And>x y z. f x (f y z) = f (f x y) z"
shows   "foldr f l e = foldl f e l"
proof -
 let ?foldr' = "\<lambda>x. foldr f x e"
 let ?foldl' = "\<lambda>(x, u). foldl f u x"
 show ?thesis
 proof (rule abs_eq[of ?foldr' _ _ ?foldl', simplified])
  fix u show "foldr f u e = (if u = [] then e else f (hd u) (foldr f (tl u) e))" by (rule foldr_prop) 
 next
  fix x show "f e x = x" by (rule mleft)
 next
  fix u e show "foldl f e u = (if u = [] then e else (\<lambda>(x, u). foldl f u x) (tl u, f e (hd u)))"
   by (simp add: foldl_prop)
 next
  fix x show "f x e = x" by (rule mright)
 next
  fix a b c show "f a (f b c) = f (f a b) c" by (rule massoc)
 qed
qed


end

